/*
  File autogenerated by gengetopt version 2.10
  generated with the following command:
  gengetopt -i extractngram.ggo -u -F extractngram_cmdline 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "getopt.h"

#include "extractngram_cmdline.h"

void
cmdline_parser_print_version (void)
{
  printf ("%s %s\n", CMDLINE_PARSER_PACKAGE, CMDLINE_PARSER_VERSION);
}

void
cmdline_parser_print_help (void)
{
  cmdline_parser_print_version ();
  printf("\n"
  "Purpose:\n"
  "  extract N-gram info from ngram table[.ngram] ptable index[.ptable] \n"
  "  and ltable index[.ltable]\n"
  "  \n"
  "  Example: extractngram -n3 -m5 -i corpus\n"
  "  will extract 3-gram, 4-gram and 5-gram statistics from corpus.ngram\n"
  "  corpus.ptable and corput.ltable previously saved with `text2ngram'\n"
  "  and write results to stdout.  if -m5 is omitted, only 3-gram is\n"
  "  extracted from ngram table.\n"
  "\n"
  "Usage: %s [OPTIONS]... [FILES]...\n", CMDLINE_PARSER_PACKAGE);
  printf("   -h         --help          Print help and exit\n");
  printf("   -V         --version       Print version and exit\n");
  printf("   -TSTRING   --to=STRING     output stream encoding (for character ngram only) (default='UTF-8')\n");
  printf("   -iSTRING   --input=STRING  ngram file name,not including .ngram\n");
  printf("   -nINT      --min-n=INT     extract N gram (where N >= n)\n");
  printf("   -mINT      --max-n=INT     extract N gram (N <= m) (max M=255,M=N if omitted)\n");
  printf("   -fINT      --freq=INT      extract N gram whose freq >= f (default='1')\n");
  printf("   -M         --mmap          use mmap() for faster operation (default=off)\n");
  printf("              --count         only count the number of N-gram extracted (default=off)\n");
  printf("   -c         --char          extract char ngram (default=off)\n");
  printf("              --nopunct       exclude N gram with (CJK) punctuations and special symbols (non-word) (default=off)\n");
}


static char *gengetopt_strdup (const char *s);

/* gengetopt_strdup() */
/* strdup.c replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

int
cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info)
{
  int c;	/* Character of the parsed option.  */
  int missing_required_options = 0;

  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->to_given = 0 ;
  args_info->input_given = 0 ;
  args_info->min_n_given = 0 ;
  args_info->max_n_given = 0 ;
  args_info->freq_given = 0 ;
  args_info->mmap_given = 0 ;
  args_info->count_given = 0 ;
  args_info->char_given = 0 ;
  args_info->nopunct_given = 0 ;
#define clear_args() { \
  args_info->to_arg = gengetopt_strdup("UTF-8") ;\
  args_info->input_arg = NULL; \
  args_info->freq_arg = 1 ;\
  args_info->mmap_flag = 0;\
  args_info->count_flag = 0;\
  args_info->char_flag = 0;\
  args_info->nopunct_flag = 0;\
}

  clear_args();

  args_info->inputs = NULL;
  args_info->inputs_num = 0;

  optarg = 0;
  optind = 1;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      char *stop_char;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "to",	1, NULL, 'T' },
        { "input",	1, NULL, 'i' },
        { "min-n",	1, NULL, 'n' },
        { "max-n",	1, NULL, 'm' },
        { "freq",	1, NULL, 'f' },
        { "mmap",	0, NULL, 'M' },
        { "count",	0, NULL, 0 },
        { "char",	0, NULL, 'c' },
        { "nopunct",	0, NULL, 0 },
        { NULL,	0, NULL, 0 }
      };

      stop_char = 0;
      c = getopt_long (argc, argv, "hVT:i:n:m:f:Mc", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          clear_args ();
          cmdline_parser_print_help ();
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
          clear_args ();
          cmdline_parser_print_version ();
          exit (EXIT_SUCCESS);

        case 'T':	/* output stream encoding (for character ngram only).  */
          if (args_info->to_given)
            {
              fprintf (stderr, "%s: `--to' (`-T') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->to_given = 1;
          args_info->to_arg = gengetopt_strdup (optarg);
          break;

        case 'i':	/* ngram file name,not including .ngram.  */
          if (args_info->input_given)
            {
              fprintf (stderr, "%s: `--input' (`-i') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->input_given = 1;
          args_info->input_arg = gengetopt_strdup (optarg);
          break;

        case 'n':	/* extract N gram (where N >= n).  */
          if (args_info->min_n_given)
            {
              fprintf (stderr, "%s: `--min-n' (`-n') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->min_n_given = 1;
          args_info->min_n_arg = strtol (optarg,&stop_char,0);
          break;

        case 'm':	/* extract N gram (N <= m) (max M=255,M=N if omitted).  */
          if (args_info->max_n_given)
            {
              fprintf (stderr, "%s: `--max-n' (`-m') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->max_n_given = 1;
          args_info->max_n_arg = strtol (optarg,&stop_char,0);
          break;

        case 'f':	/* extract N gram whose freq >= f.  */
          if (args_info->freq_given)
            {
              fprintf (stderr, "%s: `--freq' (`-f') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->freq_given = 1;
          args_info->freq_arg = strtol (optarg,&stop_char,0);
          break;

        case 'M':	/* use mmap() for faster operation.  */
          if (args_info->mmap_given)
            {
              fprintf (stderr, "%s: `--mmap' (`-M') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->mmap_given = 1;
          args_info->mmap_flag = !(args_info->mmap_flag);
          break;

        case 'c':	/* extract char ngram.  */
          if (args_info->char_given)
            {
              fprintf (stderr, "%s: `--char' (`-c') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->char_given = 1;
          args_info->char_flag = !(args_info->char_flag);
          break;


        case 0:	/* Long option with no short option */
          /* only count the number of N-gram extracted.  */
          if (strcmp (long_options[option_index].name, "count") == 0)
          {
            if (args_info->count_given)
              {
                fprintf (stderr, "%s: `--count' option given more than once\n", CMDLINE_PARSER_PACKAGE);
                clear_args ();
                exit (EXIT_FAILURE);
              }
            args_info->count_given = 1;
            args_info->count_flag = !(args_info->count_flag);
            break;
          }
          
          /* exclude N gram with (CJK) punctuations and special symbols (non-word).  */
          else if (strcmp (long_options[option_index].name, "nopunct") == 0)
          {
            if (args_info->nopunct_given)
              {
                fprintf (stderr, "%s: `--nopunct' option given more than once\n", CMDLINE_PARSER_PACKAGE);
                clear_args ();
                exit (EXIT_FAILURE);
              }
            args_info->nopunct_given = 1;
            args_info->nopunct_flag = !(args_info->nopunct_flag);
            break;
          }
          

        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          exit (EXIT_FAILURE);

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c\n", CMDLINE_PARSER_PACKAGE, c);
          abort ();
        } /* switch */
    } /* while */


  if (! args_info->input_given)
    {
      fprintf (stderr, "%s: '--input' ('-i') option required\n", CMDLINE_PARSER_PACKAGE);
      missing_required_options = 1;
    }
  if (! args_info->min_n_given)
    {
      fprintf (stderr, "%s: '--min-n' ('-n') option required\n", CMDLINE_PARSER_PACKAGE);
      missing_required_options = 1;
    }
  if ( missing_required_options )
    exit (EXIT_FAILURE);

  if (optind < argc)
    {
      int i = 0 ;
  
      args_info->inputs_num = argc - optind ;
      args_info->inputs = 
        (char **)(malloc ((args_info->inputs_num)*sizeof(char *))) ;
      while (optind < argc)
        args_info->inputs[ i++ ] = gengetopt_strdup (argv[optind++]) ; 
    }
  
  return 0;
}
